﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ImagesToBinary
{
    public partial class ImagestoBinary : Form
    {

        public ImagestoBinary()
        {
            InitializeComponent();
        }

        private void OpenButton_Click(object sender, EventArgs e)
        {
            // open each frame in the inputfolder, gamma correct the image and blank left column. 
            // Write the image to the OutputFile in a binary format that can be read by Arduino
            BinaryWriter bw;
            if (!Directory.Exists(OutputPath.Text)) Directory.CreateDirectory(OutputPath.Text);
            bw = new BinaryWriter(new FileStream(OutputPath.Text+"\\movie.bin", FileMode.Create));
            System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(BitmapPath.Text);
            int Filecount = dir.GetFiles().Length;
            for (int N = 1; N <= Filecount; N++)
            {
                string Name = BitmapPath.Text + "\\frame" + N.ToString() + ".bmp";
                pictureBox.Image = new Bitmap(Name);
                for (int row = 0; row < 32; row++) for (int col = 0; col < 64; col++)
                    {
                        Color pix = ((Bitmap)pictureBox.Image).GetPixel(col, row);
                        int val;
                        if (col == 0) val = 0; else val = pix.R;
                        Byte gammacorrected = (byte)Math.Round(63 * Math.Pow((double)val / 255.0, 2.6));
                        bw.Write(gammacorrected);
                    }
                Application.DoEvents();
            }
            bw.Close();
        }
    }
}
